	TITLE Memory 2
*******************************************************
* APLET VIDE 1.0							*
* by Jean-Yves Avenard						*
* Translation by Michal De Coninck				*
* optimizing by Noda						*
* If you want to compile it do the following things:	*
* >rplcomp Aplet.s Aplet.c					*
* >sasm -B -W -a Aplet.l -o Aplet.o Aplet.c		*
* >sload -H Aplet.m						*
*******************************************************

INCLUDE =Entry39.h
INCLUDE =Common.h
INCLUDE =Command.h
ASSEMBLE

*************************************************
*		     Name of the Aplet			*
*************************************************

	Dir_Head 8,Memory 2,601
*              ^1    ^2       ^3
* ^1=Lenght of the name of the aplet.
* ^2=Name of the aplet.
* ^3=Number of the library. This is necessary even if the library is empty. 

RPL
     StndtType			( This aplet skeleton will only provide access to the "C" type of aplet )
INCLUDE =Sharedvar.h
ASSEMBLE 
	Vfield  L34,IntTable
	CON(5)	=DOHSTR
	REL(5)  endLink
	Link	_Main	
	Link	_Entry
	Link	_Exit
	Link	_Action		( Include all the variables needed by the aplet structure )
	Link	_BackCard
	Link	_DispText
	Link	_InvertCard
	Link	_WhichCard
	Link	_PosInList

* Put here your self-made label. Don't forget to DEFINE AND INT_xx them beneath.  

endLink
RPL
DEFINE Main		INT_00
DEFINE Entry	INT_01
DEFINE Exit		INT_02
DEFINE Action	INT_03
DEFINE BackCard	INT_04
DEFINE DispText	INT_05
DEFINE InvertCard	INT_06
DEFINE WhichCard	INT_07
DEFINE PosInList	INT_08

ASSEMBLE
	Vfield  IntTable,DirVar
RPL
ASSEMBLE
	CON(5)	=DOHSTR
	REL(5)  endCode
RPL

* The HP39/40G provides a list of 91 TopicVariables that can contain any kind of object
* Instead of using local variables as on the HP48/49, it's a good idea to use these
* variables instead. The access is really fast and easy. The contain of these variables
* will be preserved while the aplet is running. If you're exiting the view or
* switch to another aplet, the content will be deleted.
* To ease the access to your variables, use alias like:

DEFINE  YTemp! TopicVar11!
DEFINE  YTemp@ TopicVar11@
DEFINE  XTemp! TopicVar10!
DEFINE  XTemp@ TopicVar10@
DEFINE  TempList! TopicVar9!
DEFINE  TempList@ TopicVar9@
DEFINE  CardsTOC! TopicVar8!
DEFINE  CardsTOC@ TopicVar8@
DEFINE  TempVar! TopicVar7!
DEFINE  TempVar@ TopicVar7@
DEFINE  RandomNumber! TopicVar6!
DEFINE  RandomNumber@ TopicVar6@
DEFINE  YPosList! TopicVar5!
DEFINE  YPosList@ TopicVar5@
DEFINE  XPosList! TopicVar4!
DEFINE  XPosList@ TopicVar4@
DEFINE  YCard! TopicVar3!
DEFINE  YCard@ TopicVar3@
DEFINE  XCard! TopicVar2!
DEFINE  XCard@ TopicVar2@
DEFINE  RandomList! TopicVar1!
DEFINE  RandomList@ TopicVar1@

ASSEMBLE
=DISPXYmini	EQU	#3F8A0				( for miniFONT )
=TOD	EQU	#3F755					( Time of Date )
RPL

DEFINE	Save@	LastBut3
DEFINE	Save!	LastBut3 REPLACE DROP

*************************************************
*	         Self-made variables			*
*************************************************
* ici

NAMELESS _Main
  ::
     StndCheck
     ' Entry
     ' Exit
     '
	::
	EnsureMenuOff
	;
     '
	::
	  {
	   { kcSymbView :: TakeOver Action ;	( Enter or Symb to continue the program )
	     kcEnter :: TakeOver Action ;
	   }
	   NULL{}
	   NULL{}
	   NULL{}
	   NULL{}
	   NULL{}
          }
          ONE KeyFace
       ;
    TRUE
   {
   {
	::
	;
    }
    }
    ONE
    '
    ::	TURNMENUON RECLAIMDISP
	ERRJMP
    ;
  ;
NAMELESS _Entry
::
*************************************************
*		Begin of the presentation		*
*************************************************

TURNMENUOFF
HARDBUFF ZEROZERO BINT_131d SIXTYFOUR GROB!ZERODRP

$ "      ~Memory 2~"
DISPROW1
$ "  Michal De Coninck"
DISPROW3
$ "ndco232@tiscalinet.be"
DISPROW5
$ " Press Enter to start"
DISPROW8

**************************************************
*		  End of the presentation		 *
**************************************************
;

NAMELESS _Action
::
*************************************************
*		      Begin of the program		*
*************************************************

TOD %RANDOMIZE

* Checks for current time on calc and take that as the seed
* For random numbers (which make it more random :)

GARBAGE

* defragmentation of the RAM

HARDBUFF ZEROZERO BINT_131d SIXTYFOUR GROB!ZERODRP	( Clear screen )

ZERO CardsTOC!					

* zero cards turned over correctly...

{ ZERO ZERO ZERO } TempList!

* List with the coordinates of the first card turned and the position of the 
* card in the list

ZERO BINT18 NDUPN {}N RandomList!

* Creates a list with 18 elements (all ZEROS)

BINT9 #1+_ONE_DO (DO)

TWO #1+_ONE_DO (DO)
BEGIN
%RAN % 18 %* %IP %1 %+ COERCE RandomNumber!
RandomList@ RandomNumber@ NTHCOMPDROP
ZERO EQ 
UNTIL
JINDEX@ RandomNumber@ RandomList@ PUTLIST RandomList!
LOOP
LOOP

* There are 9 cards. There are 2 from each card. 
* We look if a place is not occupied with a card.
* If not then we write the number from the card ( 1 - 9 ) in the RandomList
* Because there has to be 2 from each card we have do that for every
* number.
* This routine is actually not so fast, Alan Lark's is much better
* and faster (but also more complicated). Check his game out to see what

ZERO RandomNumber!

* We won't use the number RandomNumber anymore so that's why I'm
* now going to use it to see which card it is...

ONE DUP XPosList! YPosList!

* where are you in the list?

BINT6 YCard!

* Initial  Y-coordinate of the card.

THREE #1+_ONE_DO (DO)
TWO XCard!
SIX #1+_ONE_DO (DO)
BackCard
XCard@ SEVENTEEN #+ XCard!
LOOP
YCard@ SEVENTEEN #+ YCard!
LOOP

* Display 18 backs of cards on the screen.

BINT105 ZERO OVER BINT64 LINEON

BINT117 XTemp! FIVE YTemp!
EIGHT #1+_ONE_DO (DO)
HARDBUFF
XTemp@ YTemp@ 
"Memory 2" INDEX@ DUP SUB$  
$>GROB
XYGROBDISP
YTemp@ SEVEN #+ YTemp!
LOOP

BINT2 XCard! BINT6 YCard!
InvertCard

BEGIN

GETTOUCH NOT IT ZERO

kcRightArrow REPKEY? XPosList@ SIX EQUALNOT AND
IT
::
InvertCard
XCard@ BINT17 #+ XCard!
InvertCard
XPosList@ #1+ XPosList!
;						( end of Right arrow Pressed )

kcLeftArrow REPKEY? XPosList@ ONE EQUALNOT AND
IT
::
InvertCard
XCard@ BINT17 #- XCard!
InvertCard
XPosList@ #1- XPosList!
;						( end of Left arrow Pressed )

kcDownArrow REPKEY? YPosList@ THREE EQUALNOT AND
IT
::
InvertCard
YCard@ BINT17 #+ YCard!
InvertCard
YPosList@ #1+ YPosList!
;						( end of Down arrow Pressed )

kcUpArrow REPKEY? YPosList@ ONE EQUALNOT AND
IT
::
InvertCard
YCard@ BINT17 #- YCard!
InvertCard
YPosList@ #1- YPosList!
;						( end of Up arrow Pressed )

kcSymbView REPKEY? PosInList RandomList@ TempVar@ NTHCOMPDROP TEN EQUALNOT TempVar@ TempList@ THREE NTHCOMPDROP EQUALNOT AND AND
IT
::
TempList@ THREE NTHCOMPDROP ZERO EQ case
::
DROP
InvertCard
WhichCard
InvertCard
TempVar@ THREE TempList@ PUTLIST TempList!
XCard@ ONE TempList@ PUTLIST TempList!
YCard@ TWO TempList@ PUTLIST TempList!
;						( end if no cards where turned over yet )

TempList@ THREE NTHCOMPDROP ZERO EQUALNOT IT
::
InvertCard
WhichCard
RandomList@ TempList@ THREE NTHCOMPDROP NTHCOMPDROP
PosInList RandomList@ TempVar@ NTHCOMPDROP EQITE
 ::
   TEN TempList@ THREE NTHCOMPDROP RandomList@ PUTLIST RandomList!
   TEN TempVar@ RandomList@ PUTLIST RandomList!
   CardsTOC@ #1+ CardsTOC!
 ;
 ::
   %.5 DOWAIT
   BackCard
   TempList@ ONE NTHCOMPDROP
   TempList@ TWO NTHCOMPDROP
   XCard@ ONE TempList@ PUTLIST TempList!
   YCard@ TWO TempList@ PUTLIST TempList!
   YCard! XCard!
   BackCard
   TempList@ ONE NTHCOMPDROP XCard!
   TempList@ TWO NTHCOMPDROP YCard!
 ;
InvertCard
ZERO THREE TempList@ PUTLIST TempList!
;						( end of one card turned over already )

;						( end of Symb key pressed )

SLOW SLOW SLOW

kcDel REPKEY? CardsTOC@ NINE EQOR
UNTIL
CardsTOC@ NINE EQIT 
 ::
$ "You've won!"
Ck&DoMsgBox
 ;
DropJunk
Entry

**************************************************
*		       End of the program		*
**************************************************
;

NAMELESS _BackCard
::
HARDBUFF XCard@ YCard@ BINT_131d OVER SIXTEEN #+ OVER SIXTEEN #+ OVER GROB!ZERODRP
XCard@ YCard@
GROB 4A 0100001000EFF7529C394A9429529C394A9429529C394A9429529C394A9429529C394AEFF7
XYGROBDISP
* Clears position card and shows the back of the card
;							 ( end of BackCard )

NAMELESS _InvertCard
::
XCard@ YCard@
HARDBUFF
XCard@ YCard@ OVER BINT16 #+ OVER BINT16 #+
SUBGROB
INVGROB
XYGROBDISP
* invert the card
;							( end of routine to invert the card )

NAMELESS _WhichCard
::
HARDBUFF XCard@ YCard@ BINT_131d OVER SIXTEEN #+ OVER SIXTEEN #+ OVER GROB!ZERODRP

RandomList@ TempVar@ NTHCOMPDROP RandomNumber!

XCard@ YCard@

RandomNumber@ ONE EQIT GROB 4A 0100001000EFF710081028107818A818B810299F2B98E89A28DFFB90099FF81F781008EFF7

RandomNumber@ TWO EQIT
GROB 4A 0100001000EFF71008900893E89C9893E89FF89FF89C38900890089008900890081008EFF7

RandomNumber@ THREE EQIT GROB 4A 0100001000EFF71008100893C9D7EBDFFBDFFBDFFB9FF91FF81E781C38181810081008EFF7

RandomNumber@ FOUR EQIT GROB 4A 0100001000EFF710081CF912891109900ADFFB500A500A57FA579A57FA570ADFFB1008EFF7

RandomNumber@ FIVE EQIT GROB 4A 0100001000EFF71008101810381038105810D8101910981E181F181F181F181E081008EFF7

RandomNumber@ SIX EQIT GROB 4A 0100001000EFF71008181818181C38DFFB9FF91E781FF81FF897E993C9D18B500A1008EFF7

RandomNumber@ SEVEN EQIT GROB 4A 0100001000EFF7100818181FF89FF99F999E9958FB50FB96F996E9908917E818181008EFF7

RandomNumber@ EIGHT EQIT GROB 4A 0100001000EFF71008DFFB900911881A581C381E781E781C381A5811889009DFFB1008EFF7

RandomNumber@ NINE EQIT GROB 4A 0100001000EFF7100810189018110A18391C781EF8DEFE1C7818381109901A10181008EFF7

XYGROBDISP

* This checks which card it is: a house, a heart...
* And display it then on the screen
;							( end of Which Card )

NAMELESS _PosInList
::
YPosList@ #1- SIX #* XPosList@ #+ TempVar!
* Calculate the position in the list and store the result
* in TempVar 
;							( end of calculating position in list )

NAMELESS _DispText
::
HARDBUFF						( show the text on hardbuff ) 
FOUR ROLL FOUR ROLL				( take X and Y coordinate )
FOUR ROLL DUPLEN$ 				( take the string, duplicate and give length )
FOUR #* 						( length * 4 )
DISPXYmini						( Display it in miniFont *unsupported entry* )
DROP							( drop ) 
;							( end of DispText )


NAMELESS _Exit
  ::
   LeaveGraphView
  ;
ASSEMBLE
endCode
RPL
ASSEMBLE
	Vfield DirVar,DirCode

* This variable will contain all the saved parameters of the aplet
* You can add your own variable in the list

RPL
  {
  ONE		( Add your default parameters here for the variable 'save' )
  TWO
  }
ASSEMBLE
	Vfield DirCode,DirAlt
RPL
  { }
ASSEMBLE
	Vfield DirAlt,DirNot
RPL

**************************************************
*		     Note of the aplet			 *
**************************************************
* if you want to put text in a note do it here   *
* beneath, between the " "				 *
**************************************************

$ "It's memory for the HP-39/40g. It's based on Alan Lark's memory, but is faster and more graphical. On the other hand his is more challenging! Anyway enjoy playing it. The keys are:\n[arrow keys] move\n[Symb] turn card over\n\nSend any bugs, comments or suggestions to ndco232@tiscalinet.be"

ASSEMBLE
	Vfield DirNot,DirEnd
RPL
  { }
